#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <cstdlib>

int main(int argc, char* argv[]) {
  if (argc != 4) {
    fprintf(stderr, "Usage: %s TU_count static_count dynamic_count\n", argv[0]);
    return 1;
  }

  long int module_count = strtol(argv[1], NULL, 10), 
       static_count = strtol(argv[2], NULL, 10),
       dynamic_count= strtol(argv[3], NULL, 10);

  for (int i = 0; i < module_count; ++i) {
    std::stringstream output_name;
    output_name << "module_" << i << ".tmp.cc";
    std::ofstream output(output_name.str().c_str());
    if (i == 0)
      output << "int main(){}\n";

    for (int j = 0; j < static_count; ++j) {
      if (rand() % 2) output << "static ";
      if (rand() % 2) output << "const ";
      output << "int static_" << i << '_' << j << " = " << rand() <<";\n";
    }
    for (int j = 0; j < dynamic_count; ++j) {
      if (rand() % 2) output << "static ";
      output << "int initialize_" << i << '_' << j << "()";
      output << "{return " << rand() << ";}\n";
      output << "int dynamic_" << i << '_' << j << " = ";
      output << "initialize_" << i << '_' << j << "();\n";
    }
  }
}
